checkRequire("Lua_AddFriendPanel");
checkRequire("Lua_FriendPanel");
checkRequire("Lua_FriendRequestsPanel");
checkRequire("Lua_FriendBacklistPanel");
Lua_FriendManageWindow = class("Lua_FriendManageWindow", Lua_Window);
function Lua_FriendManageWindow:ctor()
    self:superCall("ctor");

    self.windowName = "Lua_FriendManageWindow";
    self.skinName = "FriendManageWindow_skin";
    self.showBlackMask = true;
    self.isClickClose = true;
    self.showClose = true;
end

function Lua_FriendManageWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.btnClose:setLocation(294, 342, 0);

    self.tabList= Array();
    self.tabList:add({ id = Lua_FriendData.FRIEND_RECOMMEND_SEARCH_TYPE, textStr = LanUtil.getValue(161012), panel = Lua_AddFriendPanel }); -- 添加好友
    self.tabList:add({ id = Lua_FriendData.FRIEND_APPLY_TYPE,            textStr = LanUtil.getValue(161013), panel = Lua_FriendRequestsPanel, redPointId = Lua_RedPointList.Friend_Manage_Apply }); -- 好友申请
    self.tabList:add({ id = Lua_FriendData.FRIEND_TYPE,                  textStr = LanUtil.getValue(161014), panel = Lua_FriendPanel }); -- 删除好友
    self.tabList:add({ id = Lua_FriendData.FRIEND_BACKLIST_TYPE,         textStr = LanUtil.getValue(161015), panel = Lua_FriendBacklistPanel }); -- 黑名单

    self.buttonList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
    self.buttonList:setLocation(0, -443, 0);
    self.buttonList:setButtonStyle("common_altas_1", "ui_common_tab_02_s", "ui_common_tab_02", 166, 69);
    self.buttonList:setButtonText(1, 6, "5C504B", "8B5E34", 30, Lua_MyUISettings.huakangFontName, UnityEngine.FontStyle.Normal);
    self.buttonList:setButtonLine("common_altas_1", "ui_common_line_013");
    self.buttonList:setButtonItem(166, 69);
    self.buttonList:setClickCallBack(self, self.onBtnClick);
    self.buttonList:setRedPoint(70, 23);
    self.buttonList:setData(self.tabList);
    self.buttonList:setSelected(1);
end

function Lua_FriendManageWindow:showWin(param)
    self:superCall("showWin", param);

    local toindex;
    if type(param) == "table" then
        toindex = param.openIndex;
        self.selectDefaultData = param.data;
    elseif type(param) == "number" or type(param) == "string" then
        toindex = tonumber(param);
    end

    if toindex ~= nil and toindex <= self.tabList:getSize() then
        self.buttonList:setSelected(toindex);
    else
        self.buttonList:setSelected(1);
    end
end

function Lua_FriendManageWindow:onBtnClick(val)
    -- 好友申请按钮红点
    if self.tabList[val].id == Lua_FriendData.FRIEND_APPLY_TYPE then
        DataCenter.redPointData:updateRedPointState(Lua_RedPointList.Friend_Manage_Apply, false);
        DataCenter.friendData:setFriendApplyToNil();
        Lua_MsgUtil.callFunc("UPDATE_FRIENDMANAGERBTN_REDPOINT", false);
    end

    if self.tabList[val].openId ~= nil and DataCenter.funcOpenData:isOpened(self.tabList[val].openId) == false then
        self.buttonList:setSelected(self.panelIndex);
        return;
    end

    self.panelIndex = val;
    local selectingPanel = self.tabList[val].panel;
    if self.curPanel ~= nil then
        self.curPanel:dispose();
        self.curPanel = nil;
    end
    self.curPanel = selectingPanel.new(self.content);
end

function Lua_FriendManageWindow:dispose()
    Lua_ProxyManager.getProxy("Lua_FriendProxy"):sGetFriendListInfo(Lua_FriendData.FRIEND_TYPE);
    if self.tabList ~= nil then
        self.tabList:dispose();
        self.tabList:clear();
        self.tabList = nil;
    end
    if self.buttonList ~= nil then
        self.buttonList:dispose();
        self.buttonList = nil;
    end
    if self.curPanel ~= nil then
        self.curPanel:dispose();
        self.curPanel = nil;
    end

    self:superCall("dispose");
end