checkRequire("Lua_FriendBasePanel");
Lua_FriendRequestsPanel = class("Lua_FriendRequestsPanel", Lua_FriendBasePanel);
function Lua_FriendRequestsPanel:ctor(p)
    self:superCall("ctor", p, "FriendRequestsPanel_skin", Lua_FriendData.FRIEND_APPLY_TYPE);
end

function Lua_FriendRequestsPanel:buildShowItem()
    self:superCall("buildShowItem");

    self.tipsTxt.text = LanUtil.getValue(161040);

    self.refusedBtn:addClickFuntion(self, self.onRefusedClick);
    self.allapplyBtn:addClickFuntion(self, self.onAllapplyBtnClick);
end

function Lua_FriendRequestsPanel:onRefusedClick()
    if #self.friendInfoArr == 0 then
        OperateAlert.showLangValue(161022);
        return;
    end

    Lua_ProxyManager.getProxy("Lua_FriendProxy"):sCheckApplyFriend(2, nil); -- self.friendInfoArr
end

function Lua_FriendRequestsPanel:onAllapplyBtnClick()
    if #self.friendInfoArr == 0 then
        OperateAlert.showLangValue(161022);
        return;
    end
    
    if DataCenter.friendData:isFriendFull() then
        OperateAlert.showLangValue(161018);
        return;
    end

    -- OperateAlert.showLangValue(161023);
    Lua_ProxyManager.getProxy("Lua_FriendProxy"):sCheckApplyFriend(1, nil); -- self.friendInfoArr
end

function Lua_FriendRequestsPanel:setPanelData()
    self:superCall("setPanelData");

    local maxCount = getConfig({"friend_const", "friend_limit","value"});
    local friendCount = #DataCenter.friendData:getFriendType(Lua_FriendData.FRIEND_TYPE):getFriendList();
    self.friendCount.text = friendCount.."/"..maxCount;
end

function Lua_FriendRequestsPanel:dispose()
    self:superCall("dispose");
end