Lua_PlayerInfoWindow = class("Lua_PlayerInfoWindow", Lua_Window);
function Lua_PlayerInfoWindow:ctor()
    self:superCall("ctor");
    
    self.windowName = "Lua_PlayerInfoWindow";
    self.skinName="PlayerInfoWindow_skin";
    self.showClose = true;
    self.showBlackMask = true;
    self.isClickClose = true;
end
function Lua_PlayerInfoWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.playerForce.alignmentValue = 2;
    self.playerForce:setLocation(298, 19);
    self.playerForce.horizontalOverflowValue = 1;
    self.playerForce.pivotValue = 5;

    --版署
    self.vipSp:setEnable(false);
    self.vipLvTxt:setEnable(false);
    self.VIPBg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_vip_number_v", 11, 224, 32, 34);
    self.VIPBg.name = "VIPBg";
    -- self.VIPBg.anchorValue = 7;
    self.vipNum = Lua_NumberImage.new(self.content);
    self.vipNum:setLocation(8, 224);
    self.vipNum.numOffsetX = -4;
    self.vipNum.numAtlas = "number";
    self.vipNum.preStr = "ui_vip_number_";

    self.palyerTitleIcon:setEnable(false);
    self.btnClose:setLocation(303, 264, 0);

    self.avatarItem = Lua_AvatarItem.new(self.content);
    self.avatarItem:setLocation(-152, 167, 0);

    self.heroList = Lua_ItemIconList.new(self.content);
    self.heroList:setLocation(0, -58, 0);
    self.heroList.canClick = true;

    self.reportBtn:addClickFuntion(self, self.onReportBtnClick);
    self.playBtn:addClickFuntion(self, self.onPlayBtnClick);
    self.moveToBacklistBtn:addClickFuntion(self, self.onMoveToBacklistBtnClick);
    self.chatBtn:addClickFuntion(self, self.onChatBtnClick);

    self:addLuaEvent("SET_PLAYERINFO", self, self.setPanelInfo);
end

function Lua_PlayerInfoWindow:showWin(param)
    if type(param) == "table" then
        self.playerId = param.id;
        self.selectDefaultData = param.data;
    elseif type(param) == "string" or type(param) == "number" then
        self.playerId = tonumber(param);
    end

    Lua_ProxyManager.getProxy("Lua_RoleProxy"):sOtherRoleId(self.playerId);
end

function Lua_PlayerInfoWindow:setPanelInfo(playerInfo)
    if playerInfo == nil then
        return;
    end
    self.playerInfo = playerInfo.show;

    self.avatarItem:setRoleDressUp(playerInfo.show.dress_info);
    -- local palyerTitleId = DataCenter.roleData:getDressUpId(Lua_DressUpDefine.MAINTYPE_TITLE, playerInfo.show.dress_info);
    -- local palyerTitleInfo = DataCenter.roleUtil:getDressUpVoById(palyerTitleId);
    -- if palyerTitleInfo ~= nil then
    --     self.palyerTitleIcon:setAltas(palyerTitleInfo.atlas, palyerTitleInfo.sprite);
    -- else
    --     self.palyerTitleIcon:setEnable(false);
    -- end

    -- self.vipLvTxt.text = playerInfo.show.vip;
    self.vipNum.num = playerInfo.show.vip;
    self.playerName.text = playerInfo.show.name;
    self.playerForce.text=LanUtil.formateStr(161004,tostring(playerInfo.show.force));
    self.playerForce:resetSize();
    self.playerForceIcon:setLocation(298 - self.playerForce.width - 13, 23)
    self.playerLegion:setLangValue(201234);
    if tonumber(playerInfo.show.league_id) ~= nil and playerInfo.show.league_name ~= nil then
        self.playerLegion.text = LanUtil.formateStr(161024, playerInfo.show.league_name)
    end

    self.chatBtn.label = DataCenter.friendData:isFriendById(self.playerId) == false and LanUtil.getValue(161025) or LanUtil.getValue(161026);

    self.playerHeroInfo = playerInfo.lineup;
    local heroVo;
    local list = playerInfo.lineup;
    local heroInforArr = Array()
    for i=1, #list do
        heroVo = Lua_HeroVo.new(list[i].hero_id);
        heroVo:fromServer(list[i]);
        heroInforArr:add(heroVo);
    end
    -- heroInforArr:sort("location",false);
    self.heroList:setArrayData(heroInforArr);
    DataCenter.heroData.otherRoleId = playerInfo.show.id;--记录其他玩家id(用于查看玩家英雄加成项属性)
end

function Lua_PlayerInfoWindow:onReportBtnClick(go)
    local tipData = {
        titleAtlas = "friend_altas",
        titleSprite = "ui_hy_title_02",
        des = LanUtil.formateStr(161028, self.playerName.text),
        posY = 40,
        btnType = 2,
        owner = self,
        sureLabel = LanUtil.getValue(161017),
        sureFun = self.onSureReportBtnClick
    };
    Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

function Lua_PlayerInfoWindow:onSureReportBtnClick(go)
    Lua_WindowUtil.openWin("Lua_PlayerReportWindow", Lua_WinParam.ACTION_OPEN, self.playerInfo);
end

function Lua_PlayerInfoWindow:onPlayBtnClick(go)
    if #self.playerHeroInfo == 0 then
        OperateAlert.show(LanUtil.formateStr(161033, self.playerInfo.name));
        return;
    end

    local friendInfo = DataCenter.friendData:getFriendType(Lua_FriendData.FRIEND_TYPE);
    local info = friendInfo:getFriendItemById(self.playerId);
    if info == nil then
        OperateAlert.showLangValue(161034);
        return;
    end

    --发送开始战斗
    Lua_ProxyManager.getProxy("Lua_FightProxy"):sStartFight(Lua_FightDefine.TEMPLATE_ID_FRIENT, 0, self.playerId);
end

function Lua_PlayerInfoWindow:onMoveToBacklistBtnClick(go)
    if not DataCenter.funcOpenData:isOpened(10231) then
        return;
    end
    local tipData = {
        titleAtlas = "friend_altas",
        titleSprite = "ui_hy_title_02",
        des = LanUtil.formateStr(161027, self.playerName.text),
        btnType = 1,
        owner = self,
        sureFun = self.onTipsSurenClick
    };
    Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

function Lua_PlayerInfoWindow:onTipsSurenClick()
    Lua_WindowUtil.openWin("Lua_PlayerInfoWindow", Lua_WinParam.ACTION_CLOSE);
    Lua_ProxyManager.getProxy("Lua_FriendProxy"):sAddBackList(self.playerId);
end

function Lua_PlayerInfoWindow:onChatBtnClick(go)
    if not DataCenter.funcOpenData:isOpened(10231, true) then
        return;
    end

    local isFriend = DataCenter.friendData:isFriendById(tonumber(self.playerId));
    self.chatBtn.label = isFriend == false and LanUtil.getValue(161025) or LanUtil.getValue(161026);

    if isFriend == true then
        local dic = {
            id = self.playerId;
            sex = DataCenter.roleData.sex;
            level = self.playerInfo.level;
            name = self.playerInfo.name;
            -- head_icon = self.playerInfo.head_id;
            dress_info = self.playerInfo.dress_info;
        };
        DataCenter.chatData:setShowPrivateList(dic);
        DataCenter.chatData.selectPrivate = self.playerId;

        Lua_WindowUtil.openWin("Lua_ChatWindow", Lua_WinParam.ACTION_OPEN, Lua_ChatData.CHANNEL_FRIEND);
        Lua_WindowUtil.openWin("Lua_PlayerInfoWindow", Lua_WinParam.ACTION_CLOSE);
    else
        self:onAddFriendClick();
    end
end

function Lua_PlayerInfoWindow:onAddFriendClick()
    if DataCenter.friendData:isFriendFull() == true then
        OperateAlert.showLangValue(161018);
        return;
    end

    self.isBacklist = DataCenter.friendData:isBacklistById(self.playerId);
    if self.isBacklist == true then
        local tipData = { des = LanUtil.getValue(161019), btnType = 1, owner = self, sureFun = self.onSureAddClick };
        Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
        return;
    end

    self:onSureAddClick();
end

function Lua_PlayerInfoWindow:onSureAddClick()
    if self.isBacklist then
        Lua_ProxyManager.getProxy("Lua_FriendProxy"):sRemoveBackList(self.playerId);
    end
    Lua_ProxyManager.getProxy("Lua_FriendProxy"):sApplyFriend(self.playerId);
    Lua_WindowUtil.openWin("Lua_PlayerInfoWindow", Lua_WinParam.ACTION_CLOSE);
end

function Lua_PlayerInfoWindow:dispose()
    if self.avatarItem ~= nil then
        self.avatarItem:dispose();
        self.avatarItem = nil;
    end
    if self.heroList ~= nil then
       self.heroList:dispose();
       self.heroList = nil;
    end
    if self.vipNum ~= nil then
        self.vipNum:dispose();
        self.vipNum = nil;
    end
    DataCenter.heroData.otherRoleId = nil;
    self:superCall("dispose");
end